#include "txtbl.h"

void
draw_init(struct draw *p, int w, int h)
{
	int sz;

	p->w = w;
	p->h = h;
	sz = w * h + 1;	
	if((p->buf = malloc(sz)) == NULL){
		fprintf(stderr, "No mem (draw)\n");
		exit(1);
	}
	memset(p->buf, ' ', sz);
	p->buf[ sz - 1 ] = '\0';
}

void
draw_fini(struct draw *p)
{
	if(p->buf == NULL) return;
	free(p->buf);
	p->buf = NULL;
}

static int
idx(struct draw *p, int x, int y)
{
	return p->w * y + x;
}

void
draw_set(struct draw *p, int x, int y, char c)
{
	int i;

	i = idx(p, x, y);
	if(p->buf[i] != ' ') return;
	p->buf[i] = c;
}

void
draw_set_x(struct draw *p, int x, int y, int n, char c)
{
	int i;

	for(i=0; i<n; i++) draw_set(p, x+i, y, c);
}

void
draw_set_y(struct draw *p, int x, int y, int n, char c)
{
	int i;

	for(i=0; i<n; i++) draw_set(p, x, y+i, c);
}

void
draw_put(struct draw *p, FILE *fp)
{
	fputs(p->buf, fp);
}

/* EOF */
