#include "txtbl.h"

int map_w, map_h;

static char map[ MAP_W_MAX ][ MAP_H_MAX ];

void
map_init(void)
{
	memset(map, 0, sizeof(map));
	map_w = map_h = 0;
}

void
map_set(int x, int y, int w, int h)
{
	int ix, iy, tw, th;

	for(iy=0; iy<h; iy++){
		for(ix=0; ix<w; ix++){
			map[x+ix][y+iy] = 1;
		}
	}
	tw = x + w;
	th = y + h;
	if(tw > map_w) map_w = tw;
	if(th > map_h) map_h = th;
}

int
map_chk(int x, int y, int w, int h)
{
	int ix, iy;

	if(x + w > MAP_W_MAX || y + h > MAP_H_MAX){
		fprintf(stderr, "Give up x+w=%d y+h=%d\n", x+w, y+h);
		exit(1);
	}
	for(iy=0; iy<h; iy++){
		for(ix=0; ix<w; ix++){
			if(map[x+ix][y+iy]) return 0;
		}
	}
	return 1;
}

/* EOF */
