#include "txtbl.h"

static int gnw, gnh;
static int *mem, *ws, *hs, *xs, *ys;

void
rawcol_init(int nw, int nh)
{
	int n, sz;

	n = nw + nh + (nw + 1) + (nh + 1);
	sz = sizeof(int) * n;
	if((mem = malloc(sz)) == NULL){
		fprintf(stderr, "No mem (rawcol_init)\n");
		exit(1);
	}
	memset(mem, 0, sz);
	ws = mem;
	hs = &ws[nw];
	xs = &hs[nh];
	ys = &xs[nw+1];

	gnw = nw;
	gnh = nh;
}

void
rawcol_fini(void)
{
	free(mem);
}

void
rawcol_calc_xy(void)
{
	int sum, i;

	sum = 0;	
	for(i=0; i<gnw; i++){
		xs[i] = sum;
		sum += ws[i];
	}
	xs[i] = sum;

	sum = 0;	
	for(i=0; i<gnh; i++){
		ys[i] = sum;
		sum += hs[i];
	}
	ys[i] = sum;
}

int
rawcol_x_get(int ix)
{
	return xs[ix];
}

int
rawcol_y_get(int iy)
{
	return ys[iy];
}

void
rawcol_w_set_ex(int ix, int v)
{
	if(ws[ix] < v) ws[ix] = v;
}

void
rawcol_h_set_ex(int iy, int v)
{
	if(hs[iy] < v) hs[iy] = v;
}

int
rawcol_w_sum(int ix, int n)
{
	int sum, i;
	
	sum = 0;
	for(i=0; i<n; i++) sum += ws[ ix + i ];
	return sum;
}

int
rawcol_h_sum(int iy, int n)
{
	int sum, i;
	
	sum = 0;
	for(i=0; i<n; i++) sum += hs[ iy + i ];
	return sum;
}

void
rawcol_w_set_ex_scat(int ix, int n, int v)
{
	int i, sum, add;

	sum = rawcol_w_sum(ix, n);
	if(sum >= v) return;

	add = v - sum;
	sum = 0;
	for(i=0; i<n; i++){ 
		sum += add;
		while(sum >= n){
			sum -= n;
			ws[ix+i]++;
		}
	}
}

void
rawcol_h_set_ex_scat(int iy, int n, int v)
{
	int i, sum, add;

	sum = rawcol_h_sum(iy, n);
	if(sum >= v) return;

	add = v - sum;
	sum = 0;
	for(i=0; i<n; i++){ 
		sum += add;
		while(sum >= n){
			sum -= n;
			hs[iy+i]++;
		}
	}
}

/* EOF */
