#include "txtbl.h"

#define CELL_MAX	1024

static void
cell_pos_calc(struct cell *arr, int n)
{
	int x, y, w, h;
	int i;
	struct cell *p;

	map_init();

	x = y = 0;
	for(i=0; i<n; i++){
		p = &arr[i];
		while(!map_chk(x, y, p->w, p->h)) x++;
		map_set(x, y, p->w, p->h);
		p->x = x;
		p->y = y;
		if(p->div == '|') x += p->w;
		else{
			x = 0;
			y++;
		}
	}
	for(i=0; i<n; i++){
		p = &arr[i];
		if(p->div == '-'){
			if(p->x + p->w < map_w) p->w = map_w - p->x;
		}
	}
}

static void
rc_calc(struct cell *arr, int n)
{
	int i;
	struct cell *p;

	for(i=0; i<n; i++){	
		p = &arr[i];
		if(p->w == 1) rawcol_w_set_ex(p->x, p->sw + 1);
		if(p->h == 1) rawcol_h_set_ex(p->y, p->sh + 1);
	}
	for(i=0; i<n; i++){	
		p = &arr[i];
		if(p->w > 1) rawcol_w_set_ex_scat(p->x, p->w, p->sw + 1);
		if(p->h > 1) rawcol_h_set_ex_scat(p->y, p->h, p->sh + 1);
	}
	rawcol_calc_xy();
}

static int
center(char *s, int w)
{
	int i;

	for(i=0; s[i] && s[i]!='\n'; i++);
	return (w - i) / 2;
}

static void
cell_draw_one(struct cell *p, struct draw *d)
{
	int i, x, y, w, h, ix, iy;
	char *s;

	x = rawcol_x_get(p->x);
	y = rawcol_y_get(p->y);
	w = rawcol_w_sum(p->x, p->w);
	h = rawcol_h_sum(p->y, p->h);

	draw_set(d, x, y, '+');
	draw_set_x(d, x+1, y, w-1, '-');
	draw_set(d, x+w, y, '+');
	draw_set_y(d, x, y+1, h-1, '|');
	draw_set(d, x, y+h, '+');

	iy = 0;
	ix = 0;
	if(p->cen) ix = center(p->s, w-1);
	for(s=p->s; *s; s++){
		if(*s == '\n'){
			ix = 0;
			if(p->cen) ix = center(s+1, w-1);
			iy++;
			continue;
		}
		draw_set(d, x+1+ix, y+1+iy, *s);
		ix++;
	}
}

static void
cell_draw(struct cell *arr, int n)
{
	int i, w, h, bufsz;
	struct draw d;
		
	w = rawcol_x_get(map_w) + 2;
	h = rawcol_y_get(map_h) + 1;

	draw_init(&d, w, h);
	draw_set_y(&d, w-1, 0, h, '\n');

	for(i=0; i<n; i++) cell_draw_one(&arr[i], &d);

	draw_set_x(&d, 1, h-1, w-3, '-');
	draw_set_y(&d, w-2, 1, h-2, '|');
	draw_set(&d, w-2, h-1, '+');

	draw_put(&d, stdout);
	draw_fini(&d);
}

int
main(int ac, char **av)
{
	struct cell cells[ CELL_MAX ];
	int i, n;

	for(i=0; cell_get(&cells[i]) != EOF; i++);
	n = i;

	cell_pos_calc(cells, n);

	rawcol_init(map_w, map_h);
	rc_calc(cells, n);
	cell_draw(cells, n);
	rawcol_fini();

	exit(0);
}

/* EOF */
